$AsciiMap = "\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F"@
	"\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1A\x1B\x1C\x1D\x1E\x1F"@
	"\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2A\x2B\x2C\x2D\x2E\x2F"@
	"\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3A\x3B\x3C\x3D\x3E\x3F"@
	"\x40\x41\x42\x43\x44\x45\x46\x47\x48\x49\x4A\x4B\x4C\x4D\x4E\x4F"@
	"\x50\x51\x52\x53\x54\x55\x56\x57\x58\x59\x5A\x5B\x5C\x5D\x5E\x5F"@
	"\x60\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6A\x6B\x6C\x6D\x6E\x6F"@
	"\x70\x71\x72\x73\x74\x75\x76\x77\x78\x79\x7A\x7B\x7C\x7D\x7E\x7F"@
	"\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F"@
	"\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F"@
	"\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF"@
	"\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF"@
	"\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF"@
	"\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF"@
	"\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF"@
	"\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF";

function ByteArraySO::FromString(%this, %string)
{
	for(%i=0;%i<strLen(%string);%i++)
		%this.byte[%i] = strPos($AsciiMap, getSubStr(%string, %i, 1)) + 1;
	%this.bytes = strLen(%string);
	return %this;
}

function ByteArraySO::ToString(%this)
{
	for(%i=0;%i<%this.bytes;%i++)
		if(%this.byte[%i] - 1 >= 0)
			%string = %string @ getSubStr($AsciiMap, %this.byte[%i] - 1, 1);
	return %string;
}

function ByteArraySO::FromBase64(%this, %string)
{
	%len = strLen(%string);
	if((%len % 4) != 0)
	{
		error("Invalid Base64 data \""@%string@"\".");
		return %this;
	}
	%finalBytes = 3;
	for(%i=0;%i<2;%i++)
		if(getSubStr(%string, %len - 1, 1) $= "=")
		{
			%string = getSubStr(%string, 0, %len--);
			%finalShift += 6; %finalBytes--;
		}
	%finalBytes %= 3;
	%base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<%len;%i++)
	{
		if(strPos(%base64, getSubStr(%string, %i, 1)) == -1)
		{
			error("Invalid Base64 data \""@%string@"\".");
			return %this;
		}
	}
	%this.bytes = 0;
	for(%i=0;%i<%len;%i++)
	{
		%datum = strPos(%base64, getSubStr(%string, %i, 1));
		%buffer <<= 6;
		%buffer |= %datum;
		%dataAdded++;
		if(%dataAdded >= 4)
		{
			%this.byte[%this.bytes] = %buffer >> 16 & 255;
			%this.byte[%this.bytes + 1] = %buffer >> 8 & 255;
			%this.byte[%this.bytes + 2] = %buffer & 255;
			%this.bytes += 3;
			%dataAdded = 0;
		}
	}
	if(%finalBytes != 0)
	{
		%buffer <<= %finalShift;
		%this.byte[%this.bytes] = (%buffer >> 16) & 255;
		if(%finalBytes == 2)
			%this.byte[%this.bytes + 1] = (%buffer >> 8) & 255;
		%this.bytes += %finalBytes;
	}
	return %this;
}

function ByteArraySO::ToBase64(%this)
{
	%base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<%this.bytes;%i++)
	{
		%byte = %this.byte[%i];
		%buffer <<= 8;
		%buffer |= %byte;
		%dataAdded++;
		if(%dataAdded >= 3)
		{
			%string = %string @ getSubStr(%base64, %buffer >> 18 & 63, 1);
			%string = %string @ getSubStr(%base64, %buffer >> 12 & 63, 1);
			%string = %string @ getSubStr(%base64, %buffer >> 6 & 63, 1);
			%string = %string @ getSubStr(%base64, %buffer & 63, 1);
			%dataAdded = 0;
		}
	}
	if(%dataAdded != 0)
	{
		%buffer <<= (3 - %dataAdded) * 8;
		%string = %string @ getSubStr(%base64, %buffer >> 18 & 63, 1);
		%string = %string @ getSubStr(%base64, %buffer >> 12 & 63, 1);
		if(%dataAdded == 2)
			%string = %string @ getSubStr(%base64, %buffer >> 6 & 63, 1);
	}
	%padding = (4 - (strLen(%string) % 4)) % 4;
	for(%i=0;%i<%padding;%i++) %string = %string @ "=";
	return %string;
}

function ByteArraySO::FromHexadecimal(%this, %string)
{
	%hex = "0123456789ABCDEF";
	%this.bytes = 0; %len = strLen(%string);
	for(%i=0;%i<%len;%i++)
	{
		%datum = striPos(%hex, getSubStr(%string, %i, 1));
		if(%datum == -1) continue;
		%byte <<= 4;
		%byte |= %datum;
		%dataAdded++;
		if(%dataAdded >= 2)
		{
			%this.byte[-1+%this.bytes++] = %byte & 255;
			%dataAdded = 0;
		}
	}
	return %this;
}

function ByteArraySO::ToHexadecimal(%this)
{
	%hex = "0123456789ABCDEF";
	for(%i=0;%i<%this.bytes;%i++)
	{
		%byte = %this.byte[%i];
		%string = %string @ getSubStr(%hex, %byte >> 4, 1);
		%string = %string @ getSubStr(%hex, %byte & 15, 1);
	}
	return %string;
}

function ByteArraySO::HammingDistance(%this, %array)
{
	%len = getMin(%this.bytes, %array.bytes);
	for(%i=0;%i<%len;%i++)
	{
		%byte0 = %this.byte[%i];
		%byte1 = %array.byte[%i];
		for(%j=0;%j<8;%j++)
		{
			%mask = 128 >> %j;
			%dist += ((%byte0 & %mask) ^ (%byte1 & %mask)) != 0;
		}
	}
	return %dist;
}

function IsValidBase64(%string)
{
	%len = strLen(%string);
	if((%len % 4) != 0)
		return 0;
	for(%i=0;%i<2;%i++)
		if(getSubStr(%string, %len - 1, 1) $= "=")
			%string = getSubStr(%string, 0, %len--);
	%base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<%len;%i++)
		if(strPos(%base64, getSubStr(%string, %i, 1)) == -1)
			return 0;
	return 1;
}