function ByteArraySO::RC4_Initialize(%array, %key)
{
	if(!isObject(%key))
		%key = new ScriptObject() { class = "ByteArraySO"; dispose = 1; };
	if(%key.bytes <= 0)
	{
		%key.bytes = 16;
		for(%i=0;%i<16;%i++)
			%key.byte[%i] = getRandom(0, 255);
	}
	for(%i=0;%i<256;%i++)
		%array.STable[%i] = %i;
	%j = 0;
	for(%i=0;%i<256;%i++)
	{
		%j = (%j + %array.STable[%i] + %key.byte[%i % %key.bytes]) % 256;
		%temp = %array.STable[%i];
		%array.STable[%i] = %array.STable[%j];
		%array.STable[%j] = %temp;
	}
	if(%key.dispose) %key.delete();
	for(%i=0;%i<1024;%i++)
	{
		%array.i = (%array.i + 1) % 256;
		%array.j = (%array.j + %array.STable[%array.i]) % 256;
		%temp = %array.STable[%array.i];
		%array.STable[%array.i] = %array.STable[%array.j];
		%array.STable[%array.j] = %temp;
	}
	return %array;
}

function ByteArraySO::RC4_Encrypt(%array, %data)
{
	if(!isObject(%data)) return;
	if(%data.bytes <= 0) return;
	%array.bytes = %data.bytes;
	for(%b=0;%b<%data.bytes;%b++)
	{
		%array.i = (%array.i + 1) % 256;
		%array.j = (%array.j + %array.STable[%array.i]) % 256;
		%temp = %array.STable[%array.i];
		%array.STable[%array.i] = %array.STable[%array.j];
		%array.STable[%array.j] = %temp;
		%out = %array.STable[(%array.STable[%array.i] + %array.STable[%array.j]) % 256];
		%array.byte[%b] = %data.byte[%b] ^ %out;
	}
	return %array;
}