if(!isObject(CWHISGUI))
new GuiControl(CWHISGUI)
{
	new GuiWindowCtrl(CWHISWindow)
	{
		position = "0 0";
		extent = "240 140";
		minExtent = "240 140";
		
		closeCommand = "Canvas.popDialog(CWHISGUI);";
		command = "Canvas.popDialog(CWHISGUI);";
		accelerator = "Escape";
		
		text = "Client Whisper";
		
		canMinimize = 0;
		canMaximize = 0;
		resizeHeight = 1;
		resizeWidth = 1;
		
		mainWindow = 1;
		
		new GuiScrollCtrl()
		{
			position = "8 32";
			extent = "224 100";
			
			horizSizing = "width";
			vertSizing = "height";
			
			profile = "ColorScrollProfile";
			
			hScrollBar = "alwaysOff";
			
			new GuiSwatchCtrl(CWHIS_PlayerList)
			{
				position = "0 0";
				extent = "224 0";
				minExtent = "224 0";
				
				color = "0 0 0 0";
				
				horizSizing = "width";
				vertSizing = "top";
			};
		};
	};
};

function CWHISGUI::addPlayer(%this, %name)
{
	%list = CWHIS_PlayerList;
	if(isObject(%list.player_[%name]))
		return;
	if(%name $= $Pref::Player::NetName)
		return;
	%pos = "0 "@%list.getCount()*20;
	%ctrl = new GuiSwatchCtrl()
	{
		position = %pos;
		extent = "224 20";
		minExtent = "224 20";
		
		color = "0 0 0 0";
		
		horizSizing = "width";
		
		target = %name;
		
		new GuiMLTextCtrl()
		{
			position = "4 1";
			extent = "216 18";
			minExtent = "216 0";
			
			horizSizing = "width";
			
			text = "<font:arial bold:20><color:222222>"@%name;
		};
		
		new GuiBitmapCtrl()
		{
			position = "188 2";
			extent = "16 16";
			minExtent = "16 16";
			
			horizSizing = "left";
			
			text = "";
			bitmap = "Add-Ons/Client_Whisper/Images/Invite";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "170 2";
			extent = "16 16";
			minExtent = "16 16";
			
			horizSizing = "left";
			
			text = "";
			bitmap = "Add-Ons/Client_Whisper/Images/Blank";
			
			command = "doNothing();";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "188 2";
			extent = "16 16";
			minExtent = "16 16";
			
			horizSizing = "left";
			
			text = "";
			bitmap = "Add-Ons/Client_Whisper/Images/Blank";
			
			command = "CWHISGUI.sendWhisperInvite($ThisControl.getGroup());";
		};
		
		new GuiBitmapCtrl()
		{
			position = "206 2";
			extent = "5 16";
			minExtent = "5 16";
			
			horizSizing = "left";
			
			text = "";
			bitmap = "Add-Ons/Client_Whisper/Images/Blank_n";
		};
	};
	%list.add(%ctrl);
	%list.player_[%name] = %ctrl;
	%cPos = %list.getPosition();
	%cExt = %list.getExtent();
	%list.resize(getWord(%cPos, 0), getWord(%cPos, 1), getWord(%cExt, 0), getMax(%list.getCount() * 20, 0));
}

function CWHISGUI::removePlayer(%this, %name)
{
	%list = CWHIS_PlayerList;
	if(!isObject(%ctrl = %list.player_[%name]))
		return;
	%ctrl.delete();
	%count = %list.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%ctrl = %list.getObject(%i);
		%ext = %ctrl.getExtent();
		%ctrl.resize(0, %i * 20, getWord(%ext, 0), getWord(%ext, 1));
	}
	%cPos = %list.getPosition();
	%cExt = %list.getExtent();
	%list.resize(getWord(%cPos, 0), getWord(%cPos, 1), getWord(%cExt, 0), getMax(%list.getCount() * 20, 0));
	%count = %this.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%window = %this.getObject(%i);
		if(%window.mainWindow)
			continue;
		if(!isObject(%window.object))
			%window.delete();
		else if(%window.object.target $= %name)
			%window.delete();
	}
}

function CWHISGUI::clearPlayers(%this)
{
	%list = CWHIS_PlayerList;
	for(%i=%list.getCount()-1;%i>=0;%i--)
		%list.getObject(%i).delete();
	%cPos = %list.getPosition();
	%cExt = %list.getExtent();
	%list.resize(getWord(%cPos, 0), getWord(%cPos, 1), getWord(%cExt, 0), 0);
	%count = %this.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%window = %this.getObject(%i);
		if(%window.mainWindow)
			continue;
		if(!isObject(%window.object))
			%window.delete();
		else if(%window.object.target $= %name)
			%window.delete();
	}
}

function CWHISGUI::setPlayerPhase(%this, %name, %phase, %working)
{
	if(!isObject(%ctrl = CWHIS_PlayerList.player_[%name])) return;
	cancel(%ctrl.transmitLoop);
	if(%phase == 5)
	{
		%bitmap = "Chat";
		%this.CreateChatWindow(%working.getID());
		%ctrl.getObject(3).command = "CWHISGUI.OpenChatWindow("@%working.getID()@");";
	}
	else if(%working) %bitmap = "Working";
	else
	{
		%bitmap = "Invite0";
		%ctrl.transmitPhase = 0;
		%ctrl.transmitLoop = %this.schedule(500, "incTransmitPhase", %ctrl);
	}
	%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/"@%bitmap);
	%ctrl.getObject(4).setBitmap("Add-Ons/Client_Whisper/Images/Phase"@%phase);
}

function CWHISGUI::incTransmitPhase(%this, %ctrl)
{
	if(!isObject(%ctrl)) return;
	cancel(%ctrl.transmitLoop); %ctrl.transmitPhase++; %ctrl.transmitPhase %= 3;
	%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/Invite"@%ctrl.transmitPhase);
	%ctrl.transmitLoop = %this.schedule(500, "incTransmitPhase", %ctrl);
}

function CWHISGUI::sendWhisperInvite(%this, %ctrl)
{
	if(!isObject(%ctrl)) return;
	%ctrl.getObject(3).command = "doNothing();";
	%handle = (-1+$CWHIS::OutHandle++) % 4096;
	%object = new SimObject() { target = %ctrl.target; };
	%array = new ScriptObject() { class = "ByteArraySO"; };
	%object.byteArray = %array;
	%array.bytes = 3;
	%array.byte0 = (%handle >> 16) & 255;
	%array.byte1 = (%handle >> 8) & 255;
	%array.byte2 = %handle & 255;
	$CWHIS::ChatObject[%handle] = %object;
	commandToServer('messageSent', "WHIS SYN "@%array.ToBase64() SPC %ctrl.target);
	CWHISGUI.setPlayerPhase(%ctrl.target, 0);
}

function CWHISGUI::getWhisperInvite(%this, %handle, %name)
{
	if(!isObject(%ctrl = CWHIS_PlayerList.player_[%name])) return;
	%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/Blank_n");
	%ctrl.getObject(2).setBitmap("Add-Ons/Client_Whisper/Images/Accept");
	%ctrl.getObject(3).setBitmap("Add-Ons/Client_Whisper/Images/Decline");
	%ctrl.getObject(2).command = "CWHIS_AcceptWhisperInvite("@%handle@", \""@expandEscape(%name)@"\");";
	%ctrl.getObject(3).command = "CWHISGUI.rejectWhisperInvite("@%handle@", \""@expandEscape(%name)@"\");";
}

function CWHISGUI::rejectWhisperInvite(%this, %handle, %name)
{
	if(!isObject(%ctrl = CWHIS_PlayerList.player_[%name])) return;
	%count = %this.getCount();
	for(%i=0;%i<%count;%i++)
		if(strStr(%this.getObject(%i).object.handle, %handle) == 0)
			return;
	%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/Invite");
	%ctrl.getObject(2).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
	%ctrl.getObject(3).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
	%ctrl.getObject(2).command = "doNothing();";
	%ctrl.getObject(3).command = "CWHISGUI.sendWhisperInvite($ThisControl.getGroup());";
	%buffer = new ScriptObject() { class = "ByteArraySO"; bytes = 3; };
	%buffer.byte0 = (%handle >> 16) & 255;
	%buffer.byte1 = (%handle >> 8) & 255;
	%buffer.byte2 = %handle & 255;
	commandToServer('messageSent', "WHIS REJ "@%buffer.ToBase64());
	%buffer.delete();
}

function CWHISGUI::createChatWindow(%this, %object)
{
	%dist = (%this.getCount() * 32) % 12;
	%pos = %dist SPC %dist;
	
	%window = new GuiWindowCtrl()
	{
		position = %pos;
		extent = "320 200";
		minExtent = "320 200";
		
		canMaximize = 0;
		canMinimize = 0;
		
		text = %object.target;
		hidden = 1;
		
		new GuiSwatchCtrl()
		{
			position = "8 28";
			extent = "304 164";
			minExtent = "304 80";
			
			horizSizing = "width";
			vertSizing = "height";
			
			color = "0 0 0 255";
			
			new GuiSwatchCtrl()
			{
				position = "1 1";
				extent = "302 145";
				minExtent = "302 145";
				
				horizSizing = "width";
				vertSizing = "height";
				
				color = "255 255 255 255";
				
				new GuiScrollCtrl()
				{
					profile = RTB_ScrollProfile;
					
					position = "0 0";
					extent = "302 145";
					minExtent = "302 145";
					
					horizSizing = "width";
					vertSizing = "height";
					
					hScrollBar = "alwaysOff";
					
					new GuiMLTextCtrl()
					{
						profile = RTB_MLEditProfile;
						
						position = "0 0";
						extent = "294 145";
						minExtent = "290 145";
						
						horizSizing = "width";
						vertSizing = "height";
					};
				};
			};
			
			new GuiTextEditCtrl()
			{
				position = "0 146";
				extent = "304 16";
				minExtent = "304 16";
				
				horizSizing = "width";
				vertSizing = "top";
				
				maxLength = 84;
			};
		};
	};
	
	%this.add(%window);
	echo("object: "@%object);
	%window.object = %object;
	%object.window = %window;
	%window.closeCommand = %window.getID()@".setVisible(0);";
	%window.chatField = %window.getObject(0).getObject(1);
	%window.chatField.altCommand = "CWHISGUI.send("@%window.getID()@");";
	%window.chatArea = %window.getObject(0).getObject(0).getObject(0).getObject(0);
	%window.setVisible(0);
}

function CWHISGUI::openChatWindow(%this, %object)
{
	if(isObject(%window = %object.window))
	{
		%window.setVisible(1);
		return;
	}
}

function CWHISGUI::send(%this, %window)
{
	if(!isObject(%object = %window.object)) return;
	%chatBox = %window.chatField;
	%string = trim(%chatBox.getValue());
	%chatBox.setValue("");
	if(%string $= "") return;
	%buffer = new ScriptObject() { class = "ByteArraySO"; };
	for(%i=0;%i<256;%i++) %sTable[%i] = %object.byteArray.STable[%i];
	%arrayI = %object.byteArray.i; %arrayJ = %object.byteArray.j;
	%object.byteArray.RC4_Encrypt(%buffer.FromString(%string));
	for(%i=0;%i<256;%i++) %object.byteArray.STable[%i] = %sTable[%i];
	%object.byteArray.i = %arrayI; %object.byteArray.j = %arrayJ;
	%buffer.bytes = strLen(%string) + 3;
	%buffer.byte0 = (%object.handle >> 16) & 255;
	%buffer.byte1 = (%object.handle >> 8) & 255;
	%buffer.byte2 = %object.handle & 255;
	for(%i=0;%i<%object.byteArray.bytes;%i++)
		%buffer.byte[%i + 3] = %object.byteArray.byte[%i];
	%base64 = %buffer.ToBase64();
	%window.sent[-1+%window.sent++] = %base64;
	commandToServer('messageSent', "WHIS"@%base64);
	%buffer.delete();
}

function CWHISGUI::addLine(%this, %window, %name, %message)
{
	%text = "<color:444444><font:Verdana Bold:12> "@%name@"<font:Verdana:12>: "@%message;
	if(%window.chatArea.getValue() !$= "") %text = "\r\n"@%text;
	%window.chatArea.setValue(%window.chatArea.getValue()@%text);
}

function CWHISGUI::onWake(%this)
{
	%res = getRes();
	%main = %this.getObject(0);
	%ext = %main.getExtent();
	%x = (getWord(%res, 0) - getWord(%ext, 0)) / 2;
	%y = (getWord(%res, 1) - getWord(%ext, 1)) / 2;
	%main.resize(%x, %y, getWord(%ext, 0), getWord(%ext, 1));
	%count = %this.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%window = %this.getObject(%i);
		if(%window.mainWindow)
			continue;
		%window.setVisible(!%window.hidden);
	}
}

if(!$CWHIS_BoundKeybind)
{
	$CWHIS_BoundKeybind = 1;
	$remapDivision[$remapCount] = "Client Whisper";
	$remapName[$remapCount] = "Toggle CWHIS GUI";
	$remapCmd[$remapCount] = "toggleCWHISGUI";
	$remapCount++;
}

function toggleCWHISGUI(%tog)
{
	if(%tog) if(CWHISGUI.isAwake())
			Canvas.popDialog(CWHISGUI);
		else Canvas.pushDialog(CWHISGUI);
}