//A -> B: "WHIS SYN [base64 3-byte value] [target name]" {3-byte handle}
//A <- B: "WHIS SYNACK [base64 14-byte value]" {3-byte identity + Int32 prime + Int32 shared + 3-byte handle}
//A -> B: "WHIS ACK [base64 4-byte value]" {3-byte identity + Int32 shared}

//A <> B: "[base64 data]" {3-byte handle + encrypted chat}

package Client_Whisper
{
	function clientcmdChatMessage(%cl, %voice, %pitch, %fullMsg, %clanPrefix, %name, %clanSuffix, %msg)
	{
		if(strPos(%msg, "WHIS ") == 0)
		{
			%len = strLen(%msg);
			if(strPos(%msg, "SYN ") == 5 && %len > 14)
			{
				%payload = getSubStr(%msg, 9, strLen(%msg) - 9);
				%handle = getSubStr(%payload, 0, 4);
				%targ = getSubStr(%payload, 5, %len - 14);
				if(%targ $= $Pref::Player::NetName)
				{
					%legal = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789/+";
					for(%i=0;%i<4;%i++)
						if(strPos(%legal, getSubStr(%handle, %i, 1)) == -1)
							%invalid = 1;
					if(!%invalid)
					{
						%buffer = new ScriptObject() { class = "ByteArraySO"; };
						%buffer.FromBase64(%handle);
						%out = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
						CWHISGUI.setPlayerPhase(%name, 0, 1);
						CWHISGUI.getWhisperInvite(%out, %name);
					}
				}
				return;
			}
			else if(strPos(%msg, "SYNACK ") == 5 && %len == 32)
			{
				%payload = getSubStr(%msg, 12, 20);
				if(CWHIS_IsValidBase64(%payload))
				{
					%buffer = new ScriptObject() { class = "ByteArraySO"; };
					%buffer.FromBase64(%payload);
					%handle = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
					if(isObject(%object = $CWHIS::ChatObject[%handle]) && !%object.connecting && %object.target $= %name)
					{
						CWHISGUI.setPlayerPhase(%object.target, 1, 1);
						%object.connecting = 1;
						%prime = %buffer.byte3 << 24 | %buffer.byte4 << 16 | %buffer.byte5 << 8 | %buffer.byte6;
						%shared = %buffer.byte7 << 24 | %buffer.byte8 << 16 | %buffer.byte9 << 8 | %buffer.byte10;
						%out = %buffer.byte11 << 16 | %buffer.byte12 << 8 | %buffer.byte13;
						if((%out & 4095) ^ %handle)
						{
							echo("Partner illegally changed our portion of the handle - cancelling connection");
							%object.delete();
							return;
						}
						%object.handle = %out;
						$CWHIS::ChatObject[%handle] = "";
						$CWHIS::ChatObject[%object.handle] = %object;
						%object.DHKEHandle = DHKE_requestPhase1Handle(%prime);
						%object.sharedValue = %shared;
						%object.CWHIS_SYNACKLoop = schedule(200, 0, "CWHIS_SYNACKLoop", %object);
					}
					%buffer.delete();
					return;
				}
			}
			else if(strPos(%msg, "ACK ") == 5 && %len == 21)
			{
				%payload = getSubStr(%msg, 9, 12);
				if(CWHIS_IsValidBase64(%payload))
				{
					%buffer = new ScriptObject() { class = "ByteArraySO"; };
					%buffer.FromBase64(%payload);
					%handle = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
					if(isObject(%object = $CWHIS::ChatObject[%handle]) && !%object.connecting && %object.target $= %name)
					{
						CWHISGUI.setPlayerPhase(%object.target, 2, 1);
						%object.connecting = 1;
						%shared = %buffer.byte3 << 24 | %buffer.byte4 << 16 | %buffer.byte5 << 8 | %buffer.byte6;
						%object.sharedValue = %shared;
						DHKE_requestPhase2Handle(%shared, %object.DHKEHandle);
						%object.CWHIS_ACKLoop = schedule(200, 0, "CWHIS_ACKLoop", %object);
					}
					%buffer.delete();
					return;
				}
			}
			else if(strPos(%msg, "CONN ") == 5 && %len == 14)
			{
				%payload = getSubStr(%msg, 10, 4);
				if(CWHIS_IsValidBase64(%payload))
				{
					%buffer = new ScriptObject() { class = "ByteArraySO"; };
					%buffer.FromBase64(%payload);
					%handle = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
					if(isObject(%object = $CWHIS::ChatObject[%handle]) && !%object.connected && %object.target $= %name)
					{
						CWHISGUI.setPlayerPhase(%object.target, 3, 1);
						%object.connected = 1;
						if(%object.ready)
						{
							CWHISGUI.setPlayerPhase(%object.target, 5, %object);
						}
					}
					%buffer.delete();
					return;
				}
			}
			else if(strPos(%msg, "REJ ") == 5 && %len == 13)
			{
				%payload = getSubStr(%msg, 9, 4);
				if(CWHIS_IsValidBase64(%payload))
				{
					%buffer = new ScriptObject() { class = "ByteArraySO"; };
					%buffer.FromBase64(%payload);
					%handle = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
					if(isObject(%object = $CWHIS::ChatObject[%handle]) && %object.target $= %name)
					{
						%object.delete();
						if(isObject(%ctrl = CWHIS_PlayerList.player_[%name]))
						{
							cancel(%ctrl.transmitLoop);
							%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/Invite");
							%ctrl.getObject(2).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
							%ctrl.getObject(3).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
							%ctrl.getObject(2).command = "doNothing();";
							%ctrl.getObject(3).command = "CWHISGUI.sendWhisperInvite($ThisControl.getGroup());";
						}
					}
					%buffer.delete();
					return;
				}
			}
		}
		else if(strPos(%msg, "WHIS") == 0 && strLen(%msg) > 8)
		{
			if(CWHIS_IsValidBase64(getSubStr(%msg, 4, strLen(%msg) - 4)))
			{
				%data = getSubStr(%msg, 4, 4);
				%buffer = new ScriptObject() { class = "ByteArraySO"; };
				%buffer.FromBase64(%data);
				%handle = %buffer.byte0 << 16 | %buffer.byte1 << 8 | %buffer.byte2;
				%base64 = getSubStr(%msg, 8, strLen(%msg) - 8);
				%count = CWHISGUI.getCount();
				for(%i=0;%i<%count;%i++)
				{
					%window = CWHISGUI.getObject(%i);
					if(%window.mainWindow)
						continue;
					if(%window.object.handle != %handle)
						continue;
					CWHISGUI.addLine(%window, %name, %window.object.byteArray.RC4_Encrypt(%buffer.FromBase64(%base64)).ToString());
					%buffer.delete();
					return;
				}
				%buffer.delete();
			}
		}
		Parent::clientcmdChatMessage(%cl, %voice, %pitch, %fullMsg, %clanPrefix, %name, %clanSuffix, %msg);
	}
	
	function secureClientCmd_ClientDrop(%name, %obj)
	{
		CWHISGUI.removePlayer(%name);
		Parent::secureClientCmd_ClientDrop(%name, %obj);
	}
	
	function secureClientCmd_ClientJoin(%name, %obj, %bl_id, %a, %b, %admin, %sa)
	{
		Parent::secureClientCmd_ClientJoin(%name, %obj, %bl_id, %a, %b, %admin, %sa);
		CWHISGUI.addPlayer(%name);
	}
	
	function disconnect()
	{
		Parent::disconnect(%a);
		CWHISGUI.clearPlayers();
	}
};
activatePackage("Client_Whisper");

function CWHIS_AcceptWhisperInvite(%handle, %target)
{
	if(!isObject(%ctrl = CWHIS_PlayerList.player_[%target])) return;
	%ctrl.getObject(1).setBitmap("Add-Ons/Client_Whisper/Images/Working");
	%ctrl.getObject(2).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
	%ctrl.getObject(3).setBitmap("Add-Ons/Client_Whisper/Images/Blank");
	%ctrl.getObject(2).command = "doNothing();";
	%ctrl.getObject(3).command = "doNothing();";
	%object = new SimObject() { target = %target; };
	%array = new ScriptObject() { class = "ByteArraySO"; };
	%object.byteArray = %array;
	%object.handle = %handle;
	%object.DHKEHandle = DHKE_requestPhase1Handle();
	%object.CWHIS_SYNLoop = schedule(200, 0, "CWHIS_SYNLoop", %object);
}

function CWHIS_SYNLoop(%object)
{
	if(!isObject(%object)) return;
	cancel(%object.CWHIS_SYNLoop);
	%handle = %object.DHKEHandle;
	%array = %object.byteArray;
	if(DHKE_phase1Ready(%handle))
	{
		%shared = DHKE_getPhase1(%handle) | 0;
		%prime = $DHKE_PrimeValue[%handle] | 0;
		%handle = %object.handle;
		%handle |= ((-1+$CWHIS::OutHandle++) % 4096) << 12;
		$CWHIS::ChatObject[%handle] = %object;
		%array.bytes = 14;
		%array.byte0 = (%object.handle >> 16) & 255;
		%array.byte1 = (%object.handle >> 8) & 255;
		%array.byte2 = %object.handle & 255;
		%array.byte3 = (%prime >> 24) & 255;
		%array.byte4 = (%prime >> 16) & 255;
		%array.byte5 = (%prime >> 8) & 255;
		%array.byte6 = %prime & 255;
		%array.byte7 = (%shared >> 24) & 255;
		%array.byte8 = (%shared >> 16) & 255;
		%array.byte9 = (%shared >> 8) & 255;
		%array.byte10 = %shared & 255;
		%array.byte11 = (%handle >> 16) & 255;
		%array.byte12 = (%handle >> 8) & 255;
		%array.byte13 = %handle & 255;
		%object.handle = %handle;
		CWHISGUI.setPlayerPhase(%object.target, 1, 0);
		commandToServer('messageSent', "WHIS SYNACK "@%array.ToBase64());
		return;
	}
	%object.CWHIS_SYNLoop = schedule(200, 0, "CWHIS_SYNLoop", %object);
}

function CWHIS_SYNACKLoop(%object)
{
	if(!isObject(%object)) return;
	cancel(%object.CWHIS_SYNACKLoop);
	%handle = %object.DHKEHandle;
	%array = %object.byteArray;
	if(!%object.DHKEMode && DHKE_phase1Ready(%handle))
	{
		%shared = DHKE_getPhase1(%handle) | 0;
		%array.bytes = 7;
		%array.byte0 = (%object.handle >> 16) & 255;
		%array.byte1 = (%object.handle >> 8) & 255;
		%array.byte2 = %object.handle & 255;
		%array.byte3 = (%shared >> 24) & 255;
		%array.byte4 = (%shared >> 16) & 255;
		%array.byte5 = (%shared >> 8) & 255;
		%array.byte6 = %shared & 255;
		CWHISGUI.setPlayerPhase(%object.target, 2, 1);
		commandToServer('messageSent', "WHIS ACK "@%array.ToBase64());
		DHKE_requestPhase2Handle(%object.sharedValue, %handle);
		%object.DHKEMode = 1;
	}
	if(DHKE_phase2Ready(%handle))
	{
		%secret = DHKE_getPhase2(%handle) | 0;
		echo("Shared secret: "@%secret);
		%hash = sha1($DHKE_PrimeValue[%handle] SPC %secret);
		%array.FromHexadecimal(%hash);
		%array.dispose = 1; %key = %array;
		%array = new ScriptObject() { class = "ByteArraySO"; };
		%array.RC4_Initialize(%key);
		%object.byteArray = %array;
		%object.ready = 1;
		%buffer = new ScriptObject() { class = "ByteArraySO"; };
		%buffer.bytes = 3;
		%buffer.byte0 = (%object.handle >> 16) & 255;
		%buffer.byte1 = (%object.handle >> 8) & 255;
		%buffer.byte2 = %object.handle & 255;
		CWHISGUI.setPlayerPhase(%object.target, 3, 0);
		commandToServer('messageSent', "WHIS CONN "@%buffer.ToBase64());
		%buffer.delete();
		if(%object.connected)
		{
			CWHISGUI.setPlayerPhase(%object.target, 5, %object);
		}
		return;
	}
	%object.CWHIS_SYNACKLoop = schedule(200, 0, "CWHIS_SYNACKLoop", %object);
}

function CWHIS_ACKLoop(%object)
{
	if(!isObject(%object)) return;
	cancel(%object.CWHIS_ACKLoop);
	%handle = %object.DHKEHandle;
	%array = %object.byteArray;
	if(DHKE_phase2Ready(%handle))
	{
		%secret = DHKE_getPhase2(%handle) | 0;
		%hash = sha1($DHKE_PrimeValue[%handle] SPC %secret);
		%array.FromHexadecimal(%hash);
		%array.dispose = 1; %key = %array;
		%array = new ScriptObject() { class = "ByteArraySO"; };
		%array.RC4_Initialize(%key);
		%object.byteArray = %array;
		%object.ready = 1;
		%buffer = new ScriptObject() { class = "ByteArraySO"; };
		%buffer.bytes = 3;
		%buffer.byte0 = (%object.handle >> 16) & 255;
		%buffer.byte1 = (%object.handle >> 8) & 255;
		%buffer.byte2 = %object.handle & 255;
		CWHISGUI.setPlayerPhase(%object.target, 3, 0);
		commandToServer('messageSent', "WHIS CONN "@%buffer.ToBase64());
		%buffer.delete();
		if(%object.connected)
		{
			CWHISGUI.setPlayerPhase(%object.target, 5, %object);
		}
		return;
	}
	%object.CWHIS_SYNACKLoop = schedule(200, 0, "CWHIS_ACKLoop", %object);
}

function CWHIS_IsValidBase64(%string)
{
	%len = strLen(%string);
	if((%len % 4) != 0)
		return 0;
	%finalBytes = 3;
	for(%i=0;%i<2;%i++)
		if(getSubStr(%string, %len - 1, 1) $= "=")
			%string = getSubStr(%string, 0, %len--);
	%base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<%len;%i++)
		if(strPos(%base64, getSubStr(%string, %i, 1)) == -1)
			return 0;
	return 1;
}

function doNothing() { }

exec("./CWHIS_GUI.cs");
exec("./ByteArraySO.cs");
exec("./ByteArraySO_RC4.cs");
exec("./Diffie-Hellman.cs");
exec("./Profiles/Profiles.cs");